; WEIX Bootloader
; 
;
;	Made by aso(andsoon@igrus.inha.ac.kr)
;
;/*
; * Weix Operating System
; * Copyright (C) 2001 Jung Won Gyo
; *
; * This program is  free software; you can  redistribute it and/or modify
; * it under the terms  of the GNU General Public  License as published by
; * the  Free Software Foundation; either version  2,  or (at your option)
; * any later version.
; *
; * This program is distributed  in the hope that  it will be  useful, but
; * WITHOUT    ANY  WARRANTY;  without   even   the  implied  warranty  of
; * MERCHANTABILITY  or  FITNESS FOR  A PARTICULAR   PURPOSE.  See the GNU
; * General Public License for more details.
; *
; * You should  have received a  copy of  the GNU  General Public  License
; * along with   this  program; if   not,  write  to   the Free   Software
; * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
; */

; for 1.44MB floopy drive.
sectors = 18

.globl begtext, begdata, begbss, endtext, enddata, endbss
.text
begtext:
.data
begdata:
.bss
begbss:
.text

.globl _main
_main:
	; ƮƮ 0x90000   űϴ.
	mov		ax, #0x07c0		; hex 0x7c0 = dec 1984
	mov		ds, ax
	mov		ax, #0x9000		; hex 0x90000 = 576k  589824
	mov		es, ax
	mov		cx, #256		; 512 bytes
	sub		si, si
	sub		di, di
	cld
	rep
	movsw
	;  ű   Դϴ.
	; AX=9000  BX=0000  CX=0001  DX=0000  SP=FFEE  BP=0000  SI=01FE  DI=01FE
	; DS=07C0  ES=9000  SS=19E1  CS=19E1  IP=0112   NV UP EI PL ZR NA PE NC
	; 19E1:0112 F3            REPZ
	; 19E1:0113 A5            MOVSW
	; -t

	; AX=9000  BX=0000  CX=0000  DX=0000  SP=FFEE  BP=0000  SI=0200  DI=0200
	; DS=07C0  ES=9000  SS=19E1  CS=19E1  IP=0114   NV UP EI PL ZR NA PE NC
	; 19E1:0114 EA19000090    JMP     9000:0019
	; -
	jmpi	go, #0x9000

go:
	;   ׸Ʈ մϴ.
	mov     di, #0x4000-12
	mov		ax, cs
	mov		ds, ax
	mov		es, ax
	mov		ss, ax
	mov		sp, di

;/*
; *  Many BIOS's default disk parameter tables will not
; *  recognize multi-sector reads beyond the maximum sector number
; *  specified in the default diskette parameter tables - this may
; *  mean 7 sectors in some cases.
; *
; *  Since single sector reads are slow and out of the question,
; *  we must take care of this by creating new parameter tables
; *  (for the first disk) in RAM.  We will set the maximum sector
; *  count to 36 - the most we will encounter on an ED 2.88.
; *
; *  High doesn't hurt.  Low does.
; *
; *  Segments are as follows: ds=es=ss=cs - INITSEG,
; *      fs = 0, gs is unused.
; */
    mov     fs, cx
    mov     bx, #0x78
    push    ds
    seg     fs
    lds     si, (bx)
    mov     cl, #6
    push    di
    rep
    movsw

    pop     di
    pop     ds
    movb    4(di), *36

    seg     fs
    mov     (bx), di
    seg     fs
    mov     2(bx), es

load_setup:
    xor     ah, ah
    xor     dl, dl
    int     0x13

    xor     dx, dx
    mov     cl, #0x02
    mov     bx, #0x0200			; 0x90200 ġ setup  ֽϴ.
    mov     ah, #0x02			; б û մϴ.
    mov     al, setup_sects		; 4 ͸ нϴ.
    int     0x13
    jnc     ok_load_setup

    push    ax          		;   ڵ带 մϴ.
    call    print_nl
    mov     bp, sp
    call    print_hex
    pop     ax

    jmp load_setup

ok_load_setup:

	; Ŀ ġ нϴ.
	mov		ah, #0x03
	xor		bh, bh	
	int 	0x10

	; WEIX ʸ մϴ.
	mov		cx, #15
	mov		bx, #0x0007
	mov		bp, #i_love_redcloak
	mov		ax, #0x1301
	int		0x10
	
	mov		ax, #0x1000		; 64k 
	mov		es, ax
	; WEIX Ŀ ̹ 0x10000  εմϴ.
	call	read_weix
	; IO  ̿Ͽ ͸ Դϴ.
	call	kill_motor

	; Ŀ ġ ˾Ƴ  0x90510 ġ  մϴ.
	mov		ah, #0x03
	xor		bh, bh
	int		0x10
	mov		[510], dx

	; setup  ִ  մϴ.  boot/weix_seting.S ñ ٶϴ.
	jmpi	0, 0x9020


loop_forever: jmp loop_forever

;--------------------------------------------------------------------------------
; ⼭ ʹ  Ŀ д  մϴ.
;--------------------------------------------------------------------------------
weix_sect:	.word	0	; Ŀ ó Ͱ ִ ġ ŵϴ.
						; (1~2) ƮƮ ڵ
						; (2~5) setup ڵ
weix_head:	.word	0	; ĿũⰡ 720k  ʴ ̻ head  ʽϴ.
weix_track:	.word	0	;  Ʈ

; Ʒʹ εϰ  bootsect ڵ尡 ϴ.
;   bootsect   ұϰ ̰ Ҽ ۿ 
;    ˼(?)  ־  ڵ忡
; ̺κ Խϴ.     ڽϴ.
read_weix:
	mov		al, setup_sects
	inc		al
	mov		weix_sect, al
	mov		ax, es
	test	ax, #0x0fff		; ES  64k  ־ մϴ.
die_weix:	jne		die_weix
	xor		bx, bx

rp_read:
	mov		ax, es
	sub		ax, #0x1000
	cmp		ax, weix_kernel_size
	jbe		ok1_read
	ret
ok1_read:
	mov		ax, #18
	sub		ax, weix_sect
	mov		cx, ax
	shl		cx, #9
	add		cx, bx
	jnc		ok2_read
	je		ok2_read
	xor		ax, ax
	sub		ax, bx
	shr		ax, #9
ok2_read:
    call 	read_track
    mov 	cx,ax
    add 	ax,weix_sect
    cmp 	ax, #18
    jne 	ok3_read
    mov 	ax,#1
    sub 	ax, weix_head
    jne 	ok4_read
    inc 	weix_track
ok4_read:
    mov 	weix_head,ax
    xor 	ax,ax
ok3_read:
    mov		weix_sect,ax
    shl 	cx,#9
    add 	bx,cx
    jnc 	rp_read
    mov 	ax,es
    add 	ah,#0x10
    mov 	es,ax
    xor 	bx,bx
    jmp 	rp_read
read_track:
    pusha
    pusha
    mov ax, #0xe2e  ; loading... message 2e = .
    mov bx, #7
    int 0x10
    popa

    mov dx,weix_track
    mov cx,weix_sect
    inc cx
    mov ch,dl
    mov dx,weix_head
    mov dh,dl
    and dx,#0x0100
    mov ah,#2

    push    dx              ; save for error dump
    push    cx
    push    bx
    push    ax

    int 0x13
    jc  bad_rt
    add sp, #8
    popa
    ret
bad_rt: push    ax              ; save error code
    call    print_all           ; ah = error, al = read
    xor ah,ah
    xor dl,dl
    int 0x13
    add sp, #10
    popa
    jmp read_track

; ͸ Դϴ. 翬 ÷Դϴ.
kill_motor:
	push	dx
	mov		al, #0
	mov		dx, #0x3f2
	outb
	pop		dx
	ret


weix_panic_truefinder_babo:	
	jmp weix_panic_truefinder_babo
print_all:
    mov cx, #5      ; error code + 4 registers
    mov bp, sp

print_loop:
    push    cx      ; save count left
    call    print_nl    ; nl for readability

    cmp cl, #5
    jae no_reg      ; see if register name is needed

    mov ax, #0xe05 + 'A - 1
    sub al, cl
    int 0x10

    mov al, #'X
    int 0x10

    mov al, #':
    int 0x10
no_reg:
    add bp, #2      ; next register
    call    print_hex   ; print it
    pop cx
    loop    print_loop
    ret

print_nl:
    mov ax, #0xe0d  ; CR
    int 0x10
    mov al, #0xa    ; LF
    int     0x10
    ret

print_hex:
    mov cx, #4      ; 4 hex digits
    mov dx, (bp)    ; load word into dx
print_digit:
    rol dx, #4      ; rotate so that lowest 4 bits are used
    mov ax, #0xe0f  ; ah = request, al = mask for nybble
    and al, dl
    add al, #0x90   ; convert al to ascii hex (four instructions)
    daa
    adc al, #0x40
    daa
    int 0x10
    loop    print_digit
    ret

; print text 
prtstr: lodsb
	and		al, al
	jz		fin
	call	prtchr
	jmp		prtstr
fin: ret

prtsp2:	call	prtspc
prtspc: mov		al, #0x20
prtchr: push	ax
	push	cx
	xor		bh, bh
	mov		cx, #0x01
	mov		ah, #0x0e
	int		0x10
	pop		cx
	pop		ax
	ret

realdata_babo:
truefinder_babo:

weix_okokok: .ascii "-"
	db	0x00
i_love_redcloak: 
	.ascii	"WEIX Loading..."

weix_prt_panic: .ascii "Oc."
	db	0x00

; weix_kernel_size  Ŀ ũ⸦ 512  Դϴ.
; WSIZE  ũƮ  Ͽ մϴ.
; boot/get_size.sh  ϼ.
weix_kernel_size:	.word	0x7F00
setup_sects: .word	4

.org	510
	dw	0xaa55
.text
endtext:
.data
enddata:
.bss
endbss:
