;/** crt0.s
; **
; ** Description:
; ** Kernel startup code 
; **
; **/

;/*
; * Weix Operating System
; * Copyright (C) 2001 Jung Won Gyo
; *
; * This program is  free software; you can  redistribute it and/or modify
; * it under the terms  of the GNU General Public  License as published by
; * the  Free Software Foundation; either version  2,  or (at your option)
; * any later version.
; *
; * This program is distributed  in the hope that  it will be  useful, but
; * WITHOUT    ANY  WARRANTY;  without   even   the  implied  warranty  of
; * MERCHANTABILITY  or  FITNESS FOR  A PARTICULAR   PURPOSE.  See the GNU
; * General Public License for more details.
; *
; * You should  have received a  copy of  the GNU  General Public  License
; * along with   this  program; if   not,  write  to   the Free   Software
; * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
; */

%macro	EXPORT	1
	GLOBAL %1
	%1:
	GLOBAL _%1
	_%1:
%endmacro

%macro	IMPORT 1
%ifdef UNDERBARS
	EXTERN _%1	; use this for GCC with DOS (DJGPP; COFF)
	%define %1 _%1
%else
	EXTERN %1	; use this for GCC with Linux (ELF)
%endif
%endmacro

	SECTION	.text
	EXPORT start
	
	jmp	boot_entry

	ALIGN	4
	EXTERN	edata
	EXTERN	end
	EXTERN	prot_to_real
	EXTERN	real_to_prot

boot_hdr:
	dd	0x1BADB002
	dd	0x00010000
	dd	0-0x1BADB002-0x00010000
	dd	boot_hdr
	dd	_start
	dd	edata
	dd	end
	dd	boot_entry

boot_entry:
	
	; ebx holds a pointer to
	; the multiboot info block
	
	mov	esp,boot_stack
	
	push	dword 0
	popf

; zero the kernel BSS
; 'end' and 'edata' are defined in the linker script (/djgpp/lib/djgpp.djl)
IMPORT edata
IMPORT end
	xor 	eax,eax
	mov	edi,edata
	mov	ecx,end
	sub	ecx,edi
	shr	ecx,2
	rep	stosd

	push	ebx		; save parameter for main

	IMPORT start_weix
	call start_weix	
	jmp	short $		; Hang


	SECTION	.bss
	ALIGNB	4
%IFDEF DEBUG
	RESB	4096
%ELSE
	RESB	1024
%ENDIF
boot_stack:
