;/*
; * Weix Operating System
; * Copyright (C) 2001 Jung Won Gyo
; *
; * This program is  free software# you can  redistribute it and/or modify
; * it under the terms  of the GNU General Public  License as published by
; * the  Free Software Foundation# either version  2,  or (at your option)
; * any later version.
; *
; * This program is distributed  in the hope that  it will be  useful, but
; * WITHOUT    ANY  WARRANTY#  without   even   the  implied  warranty  of
; * MERCHANTABILITY  or  FITNESS FOR  A PARTICULAR   PURPOSE.  See the GNU
; * General Public License for more details.
; *
; * You should  have received a  copy of  the GNU  General Public  License
; * along with   this  program# if   not,  write  to   the Free   Software
; * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
; */

.text
.globl _main
_main:
    mov     ax, cs
    mov     ds, ax
    mov     es, ax

	cli						; ͷƮ ۵ ϰ մϴ.

	; Ŀ 0x0 ġ űϴ.
	mov		ax,	#0x0000
	cld
do_move:
	mov		es, ax
	add		ax, #0x1000
	cmp		ax, #0x9000
	jz		end_move
	mov		ds, ax
	sub		di, di
	sub		si, si
	mov		cx, #0x8000
	rep
	movsw
	j		do_move
end_move:

	mov		ax, #0x9020
	mov		ds, ax

	; IDT GDT εմϴ. ⿡ õǴ  init/main.c ٽ õǰ
	; ˴ϴ. ⿡ ִ  ӽ  Ʈ ȣ   ʿ
	;  Դϴ.
	lidt	idt_48
	lgdt	gdt_48

	call	empty_8042
	mov		al, #0xD1		;  
	out		#0x64, al
	call	empty_8042
	mov		al, #0xDF		; A20  ۵ŵϴ.
	out		#0x60, al
	call	empty_8042

    xor ax,ax
    out #0xf0,al
    call    delay
    out #0xf1,al
    call    delay

	; ÷ ýÿ شϴ PIC  κԴϴ.
    mov al,#0x11        ; initialization sequence
    out #0x20,al        ; send it to 8259A-1
    call    delay
    out #0xA0,al        ; and to 8259A-2
    call    delay
    mov al,#0x20        ; start of hardware int's (0x20)
    out #0x21,al
    call    delay
    mov al,#0x28        ; start of hardware int's 2 (0x28)
    out #0xA1,al
    call    delay
    mov al,#0x04        ; 8259-1 is master
    out #0x21,al
    call    delay
    mov al,#0x02        ; 8259-2 is slave
    out #0xA1,al
    call    delay
    mov al,#0x01        ; 8086 mode for both
    out #0x21,al
    call    delay
    out #0xA1,al
    call    delay
    mov al,#0xFF        ; mask off all interrupts for now
    out #0xA1,al
    call    delay
    mov al,#0xFB        ; mask all irq's but irq2 which
    out #0x21,al        ; is cascaded

	; ȣ ȯմϴ.   ȣ ƴմϴ.
	xor		ax, ax
	inc		ax
	lmsw	ax
	jmp		fffff
fffff:
	jmpi	0, 0x8		; 0x08  GDT 2° ׸Ʈ ŵϴ.

; This routine checks that the keyboard command queue is empty
; No timeout is used - if this hangs there is something wrong with
; the machine, and we probably couldn't proceed anyway.
empty_8042:
    .word   0x00eb,0x00eb
    in  al,#0x64        ; 8042 status port
    test    al,#2       ; is input buffer full?
    jnz empty_8042      ; yes - loop
    ret

delay:
	.word	0x00eb
	ret
gdt:
    .word   0,0,0,0     ; dummy

    ;------ CODE SEGMENT = 0x8--------
    .word   0xFFFF      ; 4G - limit=2047 (2048*4096=8Mb)
    .word   0x0000      ; base address=0
    .word   0x9A00      ; code read/exec
    .word   0x00CF      ; granularity=4096, 386

    ;------ DATA SEGMENT = 0x10--------
    .word   0xFFFF      ; 4G - limit=2047 (2048*4096=8Mb)
    .word   0x0000      ; base address=0
    .word   0x9200      ; data read/write
    .word   0x00CF      ; granularity=4096, 386

idt_48:
    .word   0           ; idt limit=0
    .word   0,0         ; idt base=0L

gdt_48:
    .word   0x800			; gdt limit=2048, 256 GDT entries
    .word   512+gdt,0x9		; gdt base = 0X9xxxx
