+#ifdef CONFIG_HANGUL_CONSOLE
+#define GR_PORT_REG 0x3ce
+
+extern unsigned char *graph_mem;
+extern unsigned short bg_color;
+#endif
+
 void scrup(int currcons, unsigned int t, unsigned int b)
 {
+#ifdef CONFIG_HANGUL_CONSOLE
+	volatile int dummy;
+	int i;
+
+	outw(0x0105, GR_PORT_REG);
+	for (i = 0; i < 0x9100; i++)
+		graph_mem[i] = graph_mem[i + 0x0500];
+
+	outw(0xff08, GR_PORT_REG);
+	outw(0x0205, GR_PORT_REG);
+	for (i = 0x9100; i < 0x9600; i++) {
+		dummy = (int) graph_mem;
+		graph_mem[i] = bg_color;
+	}
+#else
 	int hardscroll = hardscroll_enabled;
 
 	if (b > video_num_lines || t >= b)
@@ -652,6 +674,7 @@
 			scr_writew(video_erase_char, d++);
 		}
 	}
+#endif
 }
 
 void
@@ -1430,7 +1453,11 @@
 		      utf_count = 0;
 		    }
 		} else {	/* no utf */
+#ifdef CONFIG_HANGUL_CONSOLE
+		  tc = c;
+#else
 		  tc = translate[toggle_meta ? (c|0x80) : c];
+#endif
 		}
 
                 /* If the original code was a control character we
@@ -1451,6 +1478,7 @@
 
 		if (vc_state == ESnormal && ok) {
 			/* Now try to find out how to display it */
+#ifndef CONFIG_HANGUL_CONSOLE
 			tc = conv_uni_to_pc(tc);
 			if ( tc == -4 ) {
                                 /* If we got -4 (not found) then see if we have
@@ -1462,7 +1490,7 @@
                         }
 			if (tc & ~console_charmask)
                                 continue; /* Conversion failed */
-
+#endif
 			if (need_wrap) {
 				cr(currcons);
 				lf(currcons);
