/** exception.h
 **
 ** Description:
 ** General exception handler. Called by all exception ISR's.
 ** The number of the original exception and errorcode are passed as
 ** parameters.
 **
 **/

#ifndef __WEIX_EXCEPTION_H_
#define __WEIX_EXCEPTION_H_

#include <weix/types.h>

#define N_EXCEPTIONS 32

extern void __divide_error(void);
extern void __debug_exception(void);
extern void __non_maskable_interrupt(void);
extern void __breakpoint(void);
extern void __overflow(void);
extern void __bounds_check(void);
extern void __invalid_opcode(void);
extern void __coprocessor_not_available(void);
extern void __double_fault(void);
extern void __coprocessor_segment_overrun(void);
extern void __invalid_TSS(void);
extern void __segment_not_present(void);
extern void __stack_exception(void);
extern void __general_protection(void);
extern void __page_fault(void);
extern void __reserved(void);
extern void __coprocessor_error(void);
extern void __alignment_check(void);

extern void exception_handler(dword edi, dword esi, dword ebp, dword esp,
                             dword ebx, dword edx, dword ecx, dword eax,
                             dword gs, dword fs, dword es, dword ds,
                             dword nr, dword errorCode,
                             dword eip, dword cs, dword eflags);
extern void setup_exceptions(void);

#define DebugBreakPoint() __asm__ __volatile__ ("int3"::)

#endif /* __WEIX_EXCEPTION_H_ */
