#ifndef _EXTRA_EXTERN_FUNCTIONS_T_T
#define _EXTRA_EXTERN_FUNCTIONS_T_T

#include <weix/sched.h>
#include <weix/fs.h>
#include <weix/major.h>
#include <weix/time.h>
#include <weix/timer.h>
#include <weix/times.h>
#include <weix/types.h>
#include <weix/wait.h>

extern struct wait_queue * run_queue_ptr;
extern struct wait_queue run_queue_list[];
extern struct wait_queue * run_queue;
extern struct blk_dev_struct block_device[];
extern int * block_dev_size[];
extern struct super_block * do_mount(int dev);
extern struct inode * namei(const char * filename);
extern int open_namei(const char * pathname, int flag, int mode,
    struct inode ** res_inode, struct inode * base);
extern int register_chrdev(unsigned int major, const char * name, struct file_operations *fops);
extern int register_blkdev(unsigned int major, const char * name, struct file_operations *fops);
extern void wait_on_inode(struct inode * inode);
extern void clear_inode(struct inode * inode);
extern int load_inode_bitmap (struct super_block * sb,
                  unsigned int block_group);
extern void sleep_on(struct my_life_schedule **p);
extern void wake_up(struct my_life_schedule **p);
extern void brelse(struct buffer_head * buf);
extern struct buffer_head * block_read(int dev,int block, int size);
extern int new_block(int dev);
extern void truncate(struct m_inode * inode);
extern void free_inode(struct m_inode * inode);
extern void ll_rw_page(int rw, int dev, int page, char * buffer);
extern unsigned short mem_map[];
extern struct inode * iget(struct super_block * sb,int nr);
extern void iput(struct inode * inode);
extern inline void wait_on_buffer(struct buffer_head * bh);
extern struct ext2_group_desc * get_group_desc (struct super_block * sb,
                        unsigned int block_group,
                        struct buffer_head ** bh);
extern int in_group_p(gid_t grp);
extern struct inode_operations chrdev_inode_operations;
extern struct inode_operations blkdev_inode_operations;
extern void set_blocksize(dev_t dev, int size);
extern void end;
extern int *blksize_size[];
extern int sys_exit(int exit_code);
extern int sys_close(unsigned int fd);
extern void verify_area(void * addr,int size);
extern int rw_char(int rw,int dev, char * buf, int count);
extern int read_pipe(struct m_inode * inode, char * buf, int count);
extern int write_pipe(struct m_inode * inode, char * buf, int count);
extern int root_mountflags;
extern int copy_page_tables(unsigned long from,unsigned long to,long size);
extern int free_page_tables(unsigned long from,unsigned long size);
extern unsigned long get_free_page(void);
extern void free_page(unsigned long addr);
extern void write_verify(unsigned long address);

extern unsigned long intr_count;
extern int irqaction(unsigned int ,struct sigaction * );
extern void schedule(void); 

extern long startup_time;
extern long kernel_mktime(struct tm *);
extern void char_device_init(void);
extern void sched_init(void);
extern void buffer_init(void);
extern int vsprintf(char *buf, const char *fmt, va_list args);
extern void hd_init(void);
extern void block_device_init(void);
extern int sys_sync();

extern void interruptible_sleep_on(struct my_life_schedule **p);
extern void __dbg_clear_to_line(void);

extern u_short key_map[][];
extern int kbd_state;
extern struct current_tty_buffer tty_buffer[];
extern int tty_buffer_ptr;

extern void rs1_interrupt(void);
extern void rs2_interrupt(void);
extern struct tty_struct tty_table[];
    
extern void view_prev_screen(void);
extern void view_next_screen(void);
extern void do_tty_interrupt(int );

extern void keyboard_interrupt();
extern void kbd_init();
extern void init_swapping(void);
extern void mount_root(void);
extern void rd_load(void);
extern struct buffer_head * breada(int dev,int first, ...);

#endif
