/** gdt.h
 **
 ** Description:
 ** Global Descriptor Table functions
 **
 **/

#ifndef __WEIX_GDT_H_
#define __WEIX_GDT_H_

#include <weix/types.h>

typedef struct descriptor
{
  /* segment limit 15:00 */
  word limit0_15;
  /* base address 15:00 */
  word base0_15;
  /* base address 23:16 */
  byte base16_23;
  /* segment type */
  byte type : 4;
  /* descriptor type */
  byte s : 1;
  /* descriptor privilege level - aka Ring */
  byte dpl : 2;
  /* segment present */
  byte p : 1;
  /* segment limit 19:16 */
  byte limit16_19 : 4;
  /* available for use by system software */
  byte avl : 1;
  /* always 0 */
  byte zero : 1;
  /* default operation size */
  byte db : 1;
  /* granularity */
  byte g : 1;
  /* base address 31:24 */
  byte base24_31;
} __attribute__ ((packed)) descriptor;

extern descriptor *GDT;
extern void setup_GDT(void);
extern void setup_descriptor(descriptor *d, dword base, dword limit, byte type, byte dpl, byte s, byte db);

#endif /* ifndef __WEIX_GDT_H_ */
