#ifndef _WEIX_GENHD_H
#define _WEIX_GENHD_H

#include <weix/types.h>

/*
 * 	genhd.h Copyright (C) 1992 Drew Eckhardt
 *	Generic hard disk header file by  
 * 		Drew Eckhardt
 *
 *		<drew@colorado.edu>
 */
	
#define EXTENDED_PARTITION 5
/* Max read/write errors/sector */
#define MAX_ERRORS  7
#define MAX_HD      2
#define MAX_PARTITION   10
#define port_read(port,buf,nr) \
__asm__("cld;rep;insw"::"d" (port),"D" (buf),"c" (nr))
#define port_write(port,buf,nr) \
__asm__("cld;rep;outsw"::"d" (port),"S" (buf),"c" (nr))
#define STAT_OK     (READY_STAT|SEEK_STAT)
#define OK_STATUS(s)    (((s)&(STAT_OK|(BUSY_STAT|WRERR_STAT|ERR_STAT)))==STAT_OK)
	
struct partition {
	unsigned char boot_ind;		/* 0x80 - active */
	unsigned char head;			/* starting head */
	unsigned char sector;		/* starting sector */
	unsigned char cyl;			/* starting cylinder */
	unsigned char sys_ind;		/* What partition type */
	unsigned char end_head;		/* end head */
	unsigned char end_sector;	/* end sector */
	unsigned char end_cyl;		/* end cylinder */
	unsigned int start_sect;	/* starting sector counting from 0 */
	unsigned int nr_sects;		/* nr of sectors in partition */
};

struct part_struct {
	long start_sect;
	long nr_sects;
	bool special_op;
	bool identified;
};

struct gendisk {
	int major;				/* major number of driver */
	char *major_name;		/* name of major driver */
	int minor_shift;		/* number of times minor is shifted to
					   			get real minor */
	int max_p;				/* maximum partitions per device */
	int max_nr;				/* maximum number of real devices */

	void (*init)(void);		/* Initialization called before we do our thing */
	struct hd_struct *part;		/* partition table */
	int *sizes;				/* size of device in blocks */
	int nr_real;			/* number of real devices */

	void *real_devices;		/* internal use */
	struct gendisk *next;
};

/*  ü ϵ ϰ  Ÿ մϴ. */
struct hdd_struct {
    /* Ÿ԰  κԴϴ. */
    int     head;           /* head */
    int     sect;           /* sector */
    int     cyl;            /* cylinder */
    int     wpcom;          /* wpcom */
    int     lzone;          /* lzone */
    int     ctl;            /* control */
    int     lbaf;           /* lba */
    uchar   dso;    /* dso */
    /* Ƽ   ü */
    union {
        struct part_struct hd_part[MAX_PARTITION];
    } u;
};
extern int NR_GENDISKS;			/* total */
extern struct gendisk *gendisk_head;	/* linked list of disks */

#endif
