/** idt.h
 **
 ** Description:
 ** Interrupt Descriptor Table functions
 **
 **/

#ifndef __WEIX_IDT_H_
#define __WEIX_IDT_H_

#include <weix/types.h>

typedef struct gate
{
  word offset0_15;
  word selector;
  byte zero;
  byte type : 5;
  byte dpl : 2;
  byte p : 1;
  word offset16_31;
} __attribute__ ((packed)) gate;

extern gate *IDT;
extern void setup_IDT(void);
extern void interrupt_IDT(gate *g, word selector, dword offset, byte dpl);
extern void trap_IDT(gate *g, word selector, dword offset, byte dpl);
extern void task_IDT(gate *g, word selector, byte dpl);

#endif /* __WEIX_IDT_H_ */
