/** kdebug.h
 **
 ** Description:
 ** Prototypes and defines for kernel debug print functions
 **
 **/

#ifndef __WEIX_KDEBUG_H_
#define __WEIX_KDEBUG_H_

#include <weix/types.h>
#include <weix/stdarg.h>
#include <weix/sched.h>

#define COL_BLACK   0x0
#define COL_BLUE    0x1
#define COL_GREEN   0x2
#define COL_CYAN    0x3
#define COL_RED     0x4
#define COL_MAGENTA 0x5
#define COL_BROWN   0x6
#define COL_GRAY    0x7
#define COL_BRIGHT	0x8
#define COL_GREY    COL_GRAY


/* show register defines */
#define SHOW_ESP	0x1

typedef byte *byteptr;

void console_cleartoline(void);
void console_init( byte bg, byte fg );
void console_clear_screen( void );
void console_set_background( byte bg );
void console_set_foregournd( byte fg );
void console_set_blink( bool setBit );
void console_set_intensity( bool setBit );
void console_goto_xy( byte x, byte y );
byte console_get_x( void );
byte console_get_y( void );
void console_putchar( char c );
void kprintf( const char *fmt, ... );
void show_CPU_reg();
void registers_handler(dword, dword edi, dword esi, dword ebp, dword esp,
                        dword ebx, dword edx, dword ecx, dword eax,
                        dword gs, dword fs, dword es, dword ds
                        );
void dump_memory(dword *, int );
void show_IDT_table(int , int );
void show_GDT_table(int , int );
void where_is1();
void where_is2();
void where_is3();
#endif
