#ifndef __SYS_PARAMS_H_
#define __SYS_PARAMS_H_

#define GFP_ATOMIC      0x01

/* TASK STRUCT */
#define NR_TASKS	64

/* GDT, IDT */
#define GDT_SIZE 	8192
#define IDT_SIZE 	256

#define LIMIT_1MB 	0xFFFFF
#define LIMIT_4GB 	0xFFFFFFFF

/* Memory and paging */

#define PHYS_BASE	0x100000

/* Paging constants */
#define PAGE_MASK	(~(PAGE_SIZE-1))

/* Page Directory */
#define PDE_SIZE		1024
#define PDE_SHIFT       22
#define PDE_MASK        PAGE_MASK

/* Page Table */
#define PTE_SIZE		1024
#define PTE_SHIFT       PAGE_SHIFT
#define PTE_MASK        PAGE_MASK

/* Intel constants */
#define PTE_VALID       0x00000001
#define PTE_WRITE       0x00000002
#define PTE_USER        0x00000004
#define PTE_WTHRU       0x00000008
#define PTE_NCACHE      0x00000010
#define PTE_REF         0x00000020
#define PTE_MOD         0x00000040
#define PTE_GLOBAL      0x00000100
#define PTE_AVAIL       (0x200|0x400|0x800)
#define PTE_PFN         0xFFFFF000

#define PDE_VALID       0x00000001
#define PDE_WRITE       0x00000002
#define PDE_USER        0x00000004
#define PDE_WTHRU       0x00000008
#define PDE_NCACHE      0x00000010
#define PDE_REF         0x00000020
#define PDE_AVAIL       (0x200|0x400|0x800)
#define PDE_PFN         0xFFFFF000

/* support 512M of RAM (you can change this to reduce size) */
#define MAX_MEMORY 512*1024*1024
#define MAX_PAGES (MAX_MEMORY >> (PAGE_SHIFT + 5))

#endif /* ifndef __SYS_PARAMS_H_ */
