#ifndef _WEIX_WAIT_H
#define _WEIX_WAIT_H

#define WNOHANG		0x00000001
#define WUNTRACED	0x00000002

#define __WCLONE	0x80000000

/* maximum of number of wait queue */
#define MAX_NR_RUN_QUEUE	16

struct wait_queue {
	struct my_life_schedule * task;
	struct wait_queue * next;
};

#define _LOW(v)     ( (v) & 0377)
#define _HIGH(v)    ( ((v) >> 8) & 0377)

#define WIFEXITED(s)    (!((s)&0xFF)
#define WIFSTOPPED(s)   (((s)&0xFF)==0x7F)
#define WEXITSTATUS(s)  (((s)>>8)&0xFF)
#define WTERMSIG(s) ((s)&0x7F)
#define WSTOPSIG(s) (((s)>>8)&0xFF)
#define WIFSIGNALED(s)  (((unsigned int)(s)-1 & 0xFFFF) < 0xFF)

pid_t wait(int *stat_loc);
pid_t waitpid(pid_t pid, int *stat_loc, int options);

struct semaphore {
	int count;
	struct wait_queue * wait;
};

#define MUTEX ((struct semaphore) { 1, NULL })

struct select_table_entry {
	struct wait_queue wait;
	struct wait_queue ** wait_address;
};

typedef struct select_table_struct {
	int nr;
	struct select_table_entry * entry;
} select_table;

#define __MAX_SELECT_TABLE_ENTRIES (4096 / sizeof (struct select_table_entry))

#endif
