/*
 * Weix Operating System
 * Copyright (C) 2001 Jung Won Gyo
 *
 * This program is  free software; you can  redistribute it and/or modify
 * it under the terms  of the GNU General Public  License as published by
 * the  Free Software Foundation; either version  2,  or (at your option)
 * any later version.
 *
 * This program is distributed  in the hope that  it will be  useful, but
 * WITHOUT    ANY  WARRANTY;  without   even   the  implied  warranty  of
 * MERCHANTABILITY  or  FITNESS FOR  A PARTICULAR   PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should  have received a  copy of  the GNU  General Public  License
 * along with   this  program; if   not,  write  to   the Free   Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

.code16
.globl divide_error, do_divide_error, get_hd0

#include <asm/segment.h>

#define STACKOFF		(0x2000 - 0x10)
#define PROTSTACKINIT	(0x8000 - 0x10)

.code32

/*  ۵  κ ϳ Դϴ. ۵  ʴ 
 * GRUB ؼ ýų  ۵  ʴµ, GRUB Ģ 
 * Ŀ ̹ 1M ̻ ϴµ, ȣ 忡 real  ȭ
 * Ŀ 1M̻ ֱ  real 尡 ų  ִ ִ ּҰ
 * 1M ѱ  triple fault  Ͼ ˴ϴ.   ذ
 *  ִ  ߿ ϳ 1M Ŀ ̹ ҷ ̴ ε,
 * GRUB   , floppy  ذ   
 * GRUB °  õǾ ִ ȯ濡 ޶    
 * ϴ κ  , κ ٸ Ŀ  1M ġ ġϱ
 *  weix 1M ű   ׸ ̶ մϴ.
 *
 * Ʒ Լ ϰ ȴٸ ִ floppy ý÷ ϸ, start_weix
 * Լ Ǳ  ؾ  մϴ. */
/*-------------------------------------------------------------------
 * real_to_prot
 *-------------------------------------------------------------------*/
real_to_prot:
	.code16

	cli
	.code32
	lgdt	gdtdesc
	.code16
	movw	$0x0001, %ax
	lmsw	%ax

	/* 0x8 == KERNEL_CS */
	.code32
	ljmp	$0x8, $protcseg

protcseg:
	/* 0x10 == KERNEL_DS */
	movw	$0x10, %ax
	movw	%ax, %ds
	movw	%ax, %es
	movw	%ax, %fs
	movw	%ax, %gs
	movw	%ax, %ss

	movl	(%esp), %eax
	movl	%eax, STACKOFF

	movl	protstack, %eax
	movl	%eax, %esp
	movl	%eax, %ebp

	movl	STACKOFF, %eax
	movl	%eax, (%esp)

	xorl	%eax, %eax

	ret

/*-------------------------------------------------------------------
 * prot_to_real
 *-------------------------------------------------------------------*/
/* not work yet */
prot_to_real:
	lgdt	gdtdesc

	movl	%esp, %eax
	movl	%eax, protstack

	movl	(%esp), %eax
	movl	%eax, STACKOFF

	movl	$STACKOFF, %eax
	movl	%eax, %esp
	movl	%eax, %ebp

	/* set up segment limits */
	/* 0x20 == REALMODE DATA SEGMENT */
	xorl	%eax, %eax
	movw	$0x20, %ax
	movw	%ax, %ds
	movw	%ax, %es
	movw	%ax, %fs
	movw	%ax, %gs
	movw	%ax, %ss

	/* 0x18 == REALMODE CODE SEGMENT */
	ljmp	$0x18, $tmpcseg

tmpcseg:
	.code16
    /* clear the PE bit of CR0 */

tmpp:
	jmp		tmpp

    movl    %cr0, %eax
    andl    $0xfffffffe, %eax
    movl    %eax, %cr0

    /* flush prefetch queue, reload %cs */
    .code32
    ljmp    $0, $realcseg
    .code16

realcseg:
    /* we are in real mode now
     * set up the real mode segment registers : DS, SS, ES
     */
    /* zero %eax */
    xorl    %eax, %eax

    movw    %ax, %ds
    movw    %ax, %es
    movw    %ax, %fs
    movw    %ax, %gs
    movw    %ax, %ss

    /* restore interrupts */
    sti

    /* return on new stack! */
    ret
	.code32

	.p2align	2
protstack:
	.long	PROTSTACKINIT

    .p2align    2   /* force 4-byte alignment */

/*-------------------------------------------------------------------
 * gdt
 *-------------------------------------------------------------------*/
gdt:
    .word   0, 0, 0, 0

    /* code segment */
    .word   0x07FF
	.word	0x0000
	.word	0x9A00
	.word	0x00C0

    /* data segment */
	.word	0x07FF
	.word	0x0000
	.word	0x9200
	.word	0x00C0

    /* 16 bit real mode CS */
    .word   0xFFFF, 0
    .byte   0, 0x9E, 0, 0

    /* 16 bit real mode DS */
    .word   0xFFFF, 0
    .byte   0, 0x92, 0, 0


/* this is the GDT descriptor */
gdtdesc:
    .word   0x27            /* limit */
    .long   gdt         /* addr */
