/*-------------------------------------------------------------------*
 * kernel/fs/namei.c
 *-------------------------------------------------------------------*/

/*
 * Weix Operating System
 * Copyright (C) 2001 Jung Won Gyo
 *
 * This program is  free software; you can  redistribute it and/or modify
 * it under the terms  of the GNU General Public  License as published by
 * the  Free Software Foundation; either version  2,  or (at your option)
 * any later version.
 *
 * This program is distributed  in the hope that  it will be  useful, but
 * WITHOUT    ANY  WARRANTY;  without   even   the  implied  warranty  of
 * MERCHANTABILITY  or  FITNESS FOR  A PARTICULAR   PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should  have received a  copy of  the GNU  General Public  License
 * along with   this  program; if   not,  write  to   the Free   Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <asm/system.h>
#include <weix/string.h>
#include <weix/errno.h>
#include <weix/fcntl.h>
#include <weix/types.h>
#include <weix/utime.h>
#include <weix/stat.h>
#include <weix/sched.h>
#include <weix/tty.h>
#include <weix/kernel.h>
#include <asm/fs_func.h>

#include <weix/extern_func_T_T.h>

/*-------------------------------------------------------------------*
 * namei
 *-------------------------------------------------------------------*/
struct inode * namei(const char * filename)
{
	struct inode * inode;
	int flag=O_RDWR, mode=0, error;

	kprintf("in namei, ");
    if (flag & (O_TRUNC | O_CREAT))
        flag |= 2;

    error = open_namei(filename,flag,mode,&inode,NULL);
    if (error) {
        kprintf("Oh~ error, ");
        return NULL;
    }

    if (inode) {
        inode->i_atime=CURRENT_TIME;
        inode->i_dirt=1;
    }
	return inode;
}

/*-------------------------------------------------------------------*
 * sys_mkdir
 *-------------------------------------------------------------------*/
int sys_mkdir(const char * pathname, int mode)
{
	return -1;
}

/*-------------------------------------------------------------------*
 * sys_rmdir
 *-------------------------------------------------------------------*/
int sys_rmdir(const char * name)
{
	return -1;
}

/*-------------------------------------------------------------------*
 * sys_unlink
 *-------------------------------------------------------------------*/
int sys_unlink(const char * name)
{
	return -1;
}

/*-------------------------------------------------------------------*
 * sys_link
 *-------------------------------------------------------------------*/
int sys_link(const char * oldname, const char * newname)
{
	return -1;
}
