/*-------------------------------------------------------------------*
 * kernel/fs/read_write.c
 *-------------------------------------------------------------------*/

/*
 * Weix Operating System
 * Copyright (C) 2001 Jung Won Gyo
 *
 * This program is  free software; you can  redistribute it and/or modify
 * it under the terms  of the GNU General Public  License as published by
 * the  Free Software Foundation; either version  2,  or (at your option)
 * any later version.
 *
 * This program is distributed  in the hope that  it will be  useful, but
 * WITHOUT    ANY  WARRANTY;  without   even   the  implied  warranty  of
 * MERCHANTABILITY  or  FITNESS FOR  A PARTICULAR   PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should  have received a  copy of  the GNU  General Public  License
 * along with   this  program; if   not,  write  to   the Free   Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <weix/stat.h>
#include <weix/errno.h>
#include <weix/types.h>
#include <weix/kernel.h>
#include <weix/sched.h>
#include <asm/fs_func.h>

#include <weix/kdebug.h>
#include <weix/extern_func_T_T.h>

/*-------------------------------------------------------------------*
 * sys_lseek
 *-------------------------------------------------------------------*/
int sys_lseek(unsigned int fd,off_t offset, int origin)
{
	kprintf("sys_write called\n");
	return -1;
}

/*-------------------------------------------------------------------*
 * sys_read
 *-------------------------------------------------------------------*/
int sys_read(unsigned int fd,char * buf,int count)
{
    struct file * file;
    struct inode * inode;

    if (fd>=NR_OPEN || !(file=current->filp[fd]) || !(inode=file->f_inode))
        return -EBADF;
    if (!file->f_op || !file->f_op->read)
        return -EINVAL;
    if (!count)
        return 0;

	/*   ˻縦  ʰ ֽϴ. ̰ ߿
	 * ū  ߱ ų  ֽϴ. */

    return file->f_op->read(inode,file,buf,count);
}

/*-------------------------------------------------------------------*
 * sys_write
 *-------------------------------------------------------------------*/
int sys_write(unsigned int fd,char * buf,int count)
{
	struct file * file;
	struct inode * inode;
	int written;

	/*   ⺻ ȯ ˻մϴ. */
	if(fd >= NR_OPEN || !(file=current->filp[fd]) || !(inode=file->f_inode))
		return -EINVAL;

	if(!count)
		return 0;
	
	if(!file->f_op || !file->f_op->write)
		return -EINVAL;


    /*   ˻縦  ʰ ֽϴ. ̰ ߿
     * ū  ߱ ų  ֽϴ. */

	/* , ùٸٸ write() ȣմϴ. */
	written = file->f_op->write(inode, file, buf, count);

	return written;
}
