/*
 * Weix Operating System
 * Copyright (C) 2001 Jung Won Gyo
 *
 * This program is  free software; you can  redistribute it and/or modify
 * it under the terms  of the GNU General Public  License as published by
 * the  Free Software Foundation; either version  2,  or (at your option)
 * any later version.
 *
 * This program is distributed  in the hope that  it will be  useful, but
 * WITHOUT    ANY  WARRANTY;  without   even   the  implied  warranty  of
 * MERCHANTABILITY  or  FITNESS FOR  A PARTICULAR   PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should  have received a  copy of  the GNU  General Public  License
 * along with   this  program; if   not,  write  to   the Free   Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <asm/fs_func.h>
#include <weix/errno.h>
#include <weix/sched.h>
#include <weix/times.h>
#include <weix/utsname.h>
#include <weix/types.h>
#include <weix/extern_func_T_T.h>

/*-------------------------------------------------------------------
 * sys_ftime
 *-------------------------------------------------------------------*/
int sys_ftime()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_mknod
 *-------------------------------------------------------------------*/
int sys_mknod()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_break
 *-------------------------------------------------------------------*/
int sys_break()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_mount
 *-------------------------------------------------------------------*/
int sys_mount()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_umount
 *-------------------------------------------------------------------*/
int sys_umount()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_ustat
 *-------------------------------------------------------------------*/
int sys_ustat(int dev,struct ustat * ubuf)
{
	return -1;
}

/*-------------------------------------------------------------------
 * sys_ptrace
 *-------------------------------------------------------------------*/
int sys_ptrace()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_stty
 *-------------------------------------------------------------------*/
int sys_stty()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_gtty
 *-------------------------------------------------------------------*/
int sys_gtty()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_rename
 *-------------------------------------------------------------------*/
int sys_rename()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_prof
 *-------------------------------------------------------------------*/
int sys_prof()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_setgid
 *-------------------------------------------------------------------*/
int sys_setgid(int gid)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_acct
 *-------------------------------------------------------------------*/
int sys_acct()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_phys
 *-------------------------------------------------------------------*/
int sys_phys()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_lock
 *-------------------------------------------------------------------*/
int sys_lock()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_mpx
 *-------------------------------------------------------------------*/
int sys_mpx()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_ulimit
 *-------------------------------------------------------------------*/
int sys_ulimit()
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_time
 *-------------------------------------------------------------------*/
int sys_time(long * tloc)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_setuid
 *-------------------------------------------------------------------*/
int sys_setuid(int uid)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_stime
 *-------------------------------------------------------------------*/
int sys_stime(long * tptr)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_times
 *-------------------------------------------------------------------*/
int sys_times(struct tms * tbuf)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_brk
 *-------------------------------------------------------------------*/
int sys_brk(unsigned long end_data_seg)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_setpgid
 *-------------------------------------------------------------------*/
int sys_setpgid(int pid, int pgid)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_getpgrp
 *-------------------------------------------------------------------*/
int sys_getpgrp(void)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_setsid
 *-------------------------------------------------------------------*/
int sys_setsid(void)
{
	if (current->uid && current->euid)
		return -EPERM;
	if (current->leader)
		return -EPERM;
	current->leader = 1;
	current->session = current->pgrp = current->pid;
	current->tty = -1;
	return current->pgrp;
}

/*-------------------------------------------------------------------
 * sys_uname
 *-------------------------------------------------------------------*/
int sys_uname(struct utsname * name)
{
	return -ENOSYS;
}

/*-------------------------------------------------------------------
 * sys_umask
 *-------------------------------------------------------------------*/
int sys_umask(int mask)
{
	return -ENOSYS;
}
