#ifndef _WEIX_THREAD_H_
#define _WEIX_THREAD_H_

#include <weix/types.h>

struct segment_desc {
    unsigned short size_low        __attribute__((packed)) ;
    unsigned int base_low    : 24 __attribute__((packed)) ;
    unsigned int type        : 4  __attribute__((packed)) ;
    unsigned int system      : 1  __attribute__((packed)) ;
    unsigned int dpl         : 2  __attribute__((packed)) ;
    unsigned int present     : 1  __attribute__((packed)) ;
    unsigned int size_high   : 4  __attribute__((packed)) ;
    unsigned int avail       : 1  __attribute__((packed)) ;
    unsigned int reserved    : 1  __attribute__((packed)) ; // set to zero
    unsigned int db_bit      : 1  __attribute__((packed)) ;
    unsigned int granularity : 1  __attribute__((packed)) ;
    unsigned char base_high       __attribute__((packed)) ;
};

struct user_context {
	struct segment_desc ldt[3];
	struct segment_desc * ldt_desc;

	void * memory;
	ulong size;
	int ref_count;

	ushort ldt_selector;

	ushort cs_selector;
	ushort ds_selector;
};

struct thread_queue {
    struct kernel_thread * head, * tail;
};

struct condition {
    struct thread_queue wait_queue;
};

struct mutex {
    int state;
    struct kernel_thread * owner;
    struct thread_queue wait_queue;
};

struct kernel_thread {
	ulong esp;
	volatile ulong num_ticks;
	int	priority;
	void * stack_page;
	struct kernel_thread * prev_thread_queue, * next_thread_queue;
	struct user_context * user_con;
	struct kernel_thread * owner;
	int ref_count;

	bool alive;
	struct mutex join_lock;
	struct condition join_cond;
};

#endif
